{
------------------------------------------------------------------------------
                             Unita MY
 - aneb soubor unitek, ktere se kazdou chvilku potrebuji
------------------------------------------------------------------------------

}
unit My;
{=========================   INTERFACE   ====================================}
interface
{----------------------------  Typy  ----------------------------------------}
uses
  Crt;
type
  StackPolozka = string;
  Stack = ^StItem;
  StItem = record
             Obsah: StackPolozka;
             Dalsi: Stack;
           end;

  SeznPolozka = string;
  Seznam = ^SezItem;
  SezItem = record
              Obsah: SeznPolozka;
              Dalsi: Seznam;
            end;

  Attrib = record
          X, Y: byte;      {Poloha Kurzoru}
           At : byte;      {Atributy Textu}
  end;

{----------------------------  Konstanty  -----------------------------------}
const
  SmallLetters: set of char = ['a'..'z'];
  CapitalLetters: set of char = ['A'..'Z'];
  aADiff = Ord ('a') - Ord('A');
  Letters: set of char = ['a'..'z', 'A'..'Z'];
  Sloupy = '۲';
  Sroub = '  ۲';
  Zed = '';
{Kody nekterych klaves}
  Tab       = #09;
  Esc       = #27;
  Enter     = #13;
  Space     = #32;
  BackSpace = #08;
{Kody klaves s dvojim nacitanim:}
  Del       = #83;
  Ins       = #82;
  Right     = #77;
  Left      = #75;
  Up        = #72;
  Down      = #80;
  PageUp    = #73;
  PageDown  = #81;
  F1        = #59;
  F2        = #60;
  F3        = #61;
  F4        = #62;
  F5        = #63;
  F6        = #64;
  F7        = #65;
  F8        = #66;
  F9        = #67;
  F10       = #68;
  Home      = #71;
  EndKey    = #79;

{----------------------------  Procedurky a fce  ----------------------------}
{ Procedurky pro praci s retezci }
function Mid (S: string; B,E: byte): string;
function Search (Text: string ; S: string; Pos: byte ): byte;
function DownCase (Z: Char): Char;
function MyDownCase (S: string): string;
function MyUpCase (S: string): string;
function NSpaces (N: byte): string;
function VycentrujRadku (Rad: string; Max: Byte): string ;
function VystredRadku (Rad: string; Max: Byte): string;
function NaPravoRadku (Rad: string; Max: Byte): string;
function NaLevoRadku (Rad: string; Max: Byte): string;
function CharInStr (C: Char; S: string): Boolean;
function SkipEndSpaces (S: string): string;
function SkipBegSpaces (S: string): string;
function SkipAllSpaces (S: string): string;
procedure SmazZnak (var S: string; Pos: Byte);
function MyVal (S: string): integer;
function MyStr (Cislo: longint): string;


{ Procedurky a fce pro praci se zasobnikem }
procedure StackInit (var Uk: Stack);
function StackEmpty (Uk: Stack): boolean;
procedure Push (var Uk: Stack; X: StackPolozka);
procedure Pop (var Uk: Stack; var X: StackPolozka);
function Akt (Uk: Stack): StackPolozka;
procedure StackPrint (Uk: Stack);
procedure StackKill (var Uk: Stack);

{ Procedurky a fce pro praci se seznamem }
procedure SeznInit (var Uk: Seznam);
function SeznEmpty (Uk: Seznam): boolean;
procedure Insert (var Uk: Seznam; X: SeznPolozka);
function IsThere (Uk: Seznam; X: SeznPolozka): boolean;
procedure TakeCase (Uk: Seznam; var X: SeznPolozka);
procedure Erase (var Uk: Seznam; X: SeznPolozka);
procedure SeznPrint (Uk: Seznam);
procedure SeznKill (var Uk: Seznam);

{ Procedurky a fce pro praci s textovymi soubory }
function ReadLine (var Fil: text): string;
procedure WriteLine (var Fil: text; R: string);
procedure PrintLine (R: string);

{ Ostatni drobne procedurky a fce }
procedure SetColors (Ink, Back: byte);
procedure Beep (Ton, Time: Word);
procedure WriteXY (X, Y: Byte; Co: string);
procedure SaveAttrib (Var OldAttr: Attrib);
procedure LoadAttrib (OldAttr: Attrib);
procedure StandartScreen;
procedure Pozadi (Vzor: string; Color: Byte);
{=======================   IMPLEMENTATION   =================================}
implementation

{                  ************************************                      }
{                  *******   TEXTOVE OPERACE   ********                      }
{                  ************************************                      }

{-----------------------------   MID   --------------------------------------}
{ Vraci cast podretezce S pocinaje B-tym znakem a E-tym konce}
function Mid (S: string; B,E: byte): string;
var i, N   : byte;
    Pom : string;

begin
  N := Length (S);
  Pom := '';
  for i := B to E do
    if i<=N then Pom := Pom + S [i];
  Mid := Pom;
end;

{-------------------------   SEARCH   ---------------------------------------}
{ Funkce hleda string S v textu Text od pozice Pos (vcetne)}
function Search (Text: string ; S: string; Pos: byte ): byte;
var i, D, N, Pom : byte;

begin {Search}
  D := Length(S);       {delka hledaneho retezce}
  N := Length(Text);    {delka textu}
  i := Pos;
  while i <= N - D + 1 do
    begin {while}
      if  S = Mid (Text, i, i + D - 1) then begin
                                              Search := i;
                                              exit;
                                            end;
      inc (i);
    end;  {while}
  Search := 0;
end; {Search}
{--------------------------------  DownCase  ---------------------------------}
function DownCase (Z: Char): Char;
var
  Pom : Byte;
begin { DownCase }
  if Z in CapitalLetters then
    begin {}
      Pom := Ord (Z);
      Inc (Pom, aADiff);
      Z := Chr (Pom);
    end; {}
  DownCase := Z;
end;  { DownCase }
{--------------------------  MyDownCase  ------------------------------------}
{ Zmeni vsechna velka pismenka na male, ostatni znaky necha byt }
function MyDownCase (S: string): string;
var i, N: byte;
    Word: string;
begin {MyDownCase}
  N := length (S);
  Word := '';
  for i := 1 to N do
    Word := Word + DownCase (S[i]);
  MyDownCase := Word;
end;  {MyDownCase}

{--------------------------  MyUpCase  --------------------------------------}
{ Zmeni vsechna mala pismenka na velke, ostatni znaky necha byt }
function MyUpCase (S: string): string;
var i, N: byte;
    Word: string;
begin {MyUpCase}
  N := length (S);
  Word := '';
  for i := 1 to N do
    Word := Word + UpCase (S [i]);
  MyUpCase := Word;
end;  {MyDownCase}
{-----------------------  NSpaces  ------------------------------------------}
{ Fce vraci retezec obsahujici N mezer }
function NSpaces (N: byte): string;
var i : byte;
    Pom : string;
begin {NSpaces}
  Pom := '';
  for i := 1 to N do Pom := Pom + ' ';
  NSpaces := Pom;
end; {NSpaces}
{-------------------------  VycentrujRadku  ---------------------------------}
{ Vycentruje radku Rad az na delku Max (tim, ze na kraje prida stejne
  mnozstvi mezer }
function VycentrujRadku (Rad: string; Max: Byte): string ;
var
  N, i: Byte;
  Pridej: Byte;
begin { VycentrujRadku }
  N := Length (Rad);
  Pridej := Max - N;
  VycentrujRadku := NSpaces (Pridej div 2) + Rad + NSpaces (Pridej - (Pridej
                    div 2));
end;  { VycentrujRadku }

{---------------------------  VystredRadku  ---------------------------------}
{ Vystredi radku Rad az na delku Max (tim, ze zvetsi mezery mezi slovy }
function VystredRadku (Rad: string; Max: Byte): string;
var
  N, NSp, i, Pridej, Zbytek: Byte;
  Pom : string;
begin { VystredRadku }
  N := Length (Rad);
  NSp := 0;         {Pocet mezer v radku}
  Pridej := 0;
  for i := 1 to N do
    if Rad[i] = ' ' then Inc (NSp);
  if NSp <> 0 then
    begin { NSp <> 0 }
      Pridej := (Max - N) div NSp;
      Zbytek := (Max - N) mod NSp;
      Pom := '';
      for i := 1 to N do
        begin {}
          Pom := Pom + Rad [i];
          if Rad [i] = ' ' then
            begin
	      Pom := Pom + NSpaces (Pridej);
              if Zbytek > 0 then
                begin
	          Dec (Zbytek);
                  Pom := Pom + ' ';
                end;
            end;
        end; {}
    end   { NSp <> 0 }
  else Pom := Rad;
  VystredRadku := Pom;
end;  { VystredRadku }

{---------------------------  NaPravoRadku  ---------------------------------}
{ Vystredeni radky n apravy prapor
  Prida na zacatek (Max - N) mezer }
function NaPravoRadku (Rad: string; Max: Byte): string;
var
  N: Byte;
begin { NaPravoRadku }
  N := Length (Rad);
  NaPravoRadku := NSpaces (Max - N) + Rad;
end;  { NaPravoRadku }

{----------------------------  NaLevoRadku  ---------------------------------}
{ Vystredeni radky na levy prapor
  Vicemene doplni k radku Rad (Max - N) mezer  }
function NaLevoRadku (Rad: string; Max: Byte): string;
var
  N: Byte;
begin { NaLevoRadku }
  N := Length (Rad);
  NaLevoRadku := Rad + NSpaces (Max - N);
end;  { NaLevoRadku }

{------------------------------  CharInStr  ---------------------------------}
{  Zjisti, zda se dany znak nachazi ve stringu S }
function CharInStr (C: Char; S: string): Boolean;
var
  i, N: Byte;
  Pom : Boolean;
begin { CharInStr }
  N := length (S);
  Pom := False;
  for i := 1 to N do
    if S[i] = C then Pom := True;
  CharInStr := Pom;
end;  { CharInStr }

{--------------------------  SkipEndSpaces  ---------------------------------}
function SkipEndSpaces (S: string): string;
var
  i: Byte;
begin { SkipEndSpaces }
  i := Length (S);
  while (S[i] = ' ') and (i>0) do Dec (i);
  SkipEndSpaces := Mid (S,1,i);
end;  { SkipEndSpaces }
{--------------------------  SkipBegSpaces  ---------------------------------}
function SkipBegSpaces (S: string): string;
var
  i, N: Byte;
begin { SkipBegSpaces }
  i := 1;
  N := Length (S);
  while (i < N) and (S[i] = ' ') do Inc (i);
  SkipBegSpaces := Mid (S, i, N)
end;  { SkipBegSpaces }
{--------------------------  SkipAllSpaces  ---------------------------------}
function SkipAllSpaces (S: string): string;
var
  i, N: Byte;
  Pom : string;
begin { SkipAllSpaces }
  i := 1;
  N := Length (S);
  Pom := '';
  for i := 1 to N do
    if S[i] <> ' ' then Pom := Pom + S[i];
  SkipAllSpaces := Pom;
end;  { SkipAllSpaces }

{-------------------------------  SmazZnak  ---------------------------------}
procedure SmazZnak (var S: string; Pos: Byte);
var
  N: Byte;
  Pom : string;
begin { SmazZnak }
  N := Length (S);
  Pom := Mid (S, 1, Pos - 1) + Mid (S, Pos + 1, N);
  S := Pom;
end;  { SmazZnak }
{----------------------------------  MyVal  ---------------------------------}
{ String --> cislo}
function MyVal (S: string): integer;
var
  Pom1, Pom2 : Integer;
begin { MyVal }
  Val (S, Pom1, Pom2);
  MyVal := Pom1;
end;  { MyVal }
{----------------------------------  MyStr  ---------------------------------}
{ Cislo --> String }
function MyStr (Cislo: longint): string;
var
  Vysledek : string;
begin { MyStr }
  Str (Cislo, Vysledek);
  MyStr := Vysledek;
end;  { MyStr }

{----------------------------------------------------------------------------}

{                     *****************************                          }
{                     *******   ZASOBNIK   ********                          }
{                     *****************************                          }

{--------------------------  StackInit   ------------------------------------}
{  Vytvori prazdny zasobnik  }
procedure StackInit (var Uk: Stack);
begin  {StackInit}
  Uk := nil;
end;   {StackInit}
{--------------------------  StackEmpty  ------------------------------------}
{  Testuje zda je dany zasobnik prazdny  }
function StackEmpty (Uk: Stack): boolean;
begin  {StackEmpty}
  StackEmpty := Uk = nil;
end;   {StackEmpty}
{---------------------------------  Push  -----------------------------------}
{  Vrazi na vrchol zasobniku polozku X }
procedure Push (var Uk: Stack; X: StackPolozka);
var Pom: Stack;
begin {Push}
  new (Pom);
  Pom^.Obsah := X;
  Pom^.Dalsi := Uk;
  Uk := Pom;
end;  {Push}
{---------------------------------  Pop  ------------------------------------}
{ Vybere polozku z vrcholu zasobniku }
procedure Pop (var Uk: Stack; var X: StackPolozka);
var Pom: Stack;
begin  {Pop}
  if not StackEmpty (Uk) then
    begin  {NotEmpty}
      X := Uk^.Obsah;
      Pom := Uk;
      Uk := Uk^.Dalsi;
      dispose (Pom);
    end    {NotEmpty}
  else writeln ('--- Zasobnik je prazdnej! ---');
end;  {Pop}
{-------------------------  Akt  --------------------------------------------}
function Akt (Uk: Stack): StackPolozka;
{ Vraci hodnotu polozky na vrcholu zasobniku (nechava ji tam) }
begin  {Akt}
  if Uk <> nil then Akt := Uk^.Obsah
    else writeln ('--- Zasobnik je prazdnej! ---');
end;   {Akt}
{------------------------  StackPrint  --------------------------------------}
procedure StackPrint (Uk: Stack);
begin  {StackPrint}
  writeln;
  while Uk <> nil do
    begin {while}
      Writeln (Uk^.Obsah);
      Uk := Uk^.Dalsi
    end;  {while}
end;   {StackPrint}
{-------------------------  StackKill  --------------------------------------}
procedure StackKill (var Uk: Stack);
var Pom : Stack;
begin {StackKill}
  while Uk <> nil do
    begin {while}
      Pom := Uk;
      Uk := Uk^.Dalsi;
      dispose (Pom);
    end;  {while}
end;  {StackKill}
{----------------------------------------------------------------------------}

{                        ***************************                         }
{                        *******   SEZNAM   ********                         }
{                        ***************************                         }

{--------------------------   SeznInit   ------------------------------------}
{  Vytvori prazdny seznam  }
procedure SeznInit (var Uk: Seznam);
begin  {SeznInit}
  Uk := nil;
end;   {SeznInit}
{---------------------------  SeznEmpty  ------------------------------------}
{  Testuje zda je dany seznam prazdny  }
function SeznEmpty (Uk: Seznam): boolean;
begin  {SeznEmpty}
  SeznEmpty := Uk = nil;
end;   {SeznEmpty}
{---------------------------------  Insert  ---------------------------------}
{  Vrazi na zacatek seznamu polozku X }
procedure Insert (var Uk: Seznam; X: SeznPolozka);
var Pom: Seznam;
begin {Insert}
  new (Pom);
  Pom^.Obsah := X;
  Pom^.Dalsi := Uk;
  Uk := Pom;
end;  {Insert}
{-----------------------------------  IsThere  ------------------------------}
{  Hleda polozku X v danem seznamu, vraci true - nalezen, false - nenalezen }
function IsThere (Uk: Seznam; X: SeznPolozka): boolean;
var Found : boolean;
begin {IsThere}
  Found := false;
  while (Uk <> nil) and not Found do
    begin {while}
      if Uk^.Obsah = X then Found := true;
      Uk := Uk^.Dalsi;
    end;  {while}
  IsThere := Found;
end;  {isthere}
{------------------------------ TakeCase ------------------------------------}
{  Vybere ze seznamu danou polozku (jako parametr vstupuje polozka, ktera se
od te v seznamu muze lisit pouze malymi ci velkymi pismeny) }
procedure TakeCase (Uk: Seznam; var X: SeznPolozka);
var Found : boolean;
begin {Take}
  X := MyDownCase (X);
  Found := false;
  while (Uk <> nil) and not Found do
    begin {while}
      if MyDownCase (Uk^.Obsah) = X then
        begin
          Found := true;
          X := Uk^.Obsah;
        end;
      { Ten DownCase tam bude nekdy zlobit }
      Uk := Uk^.Dalsi;
    end;  {while}
end;  {Take}

{----------------------------  Erase  ---------------------------------------}
{  Smaze polozku X ze seznamu  }
procedure Erase (var Uk: Seznam; X: SeznPolozka);
var Pom, PredPom: Seznam;
begin {Erase}
  Pom := Uk;
  PredPom := Uk;
  while Pom <> nil do
    begin {while}
      if Pom^.Obsah = X then
        begin {nalezen}
          if Pom = Uk then Uk := Uk^.Dalsi  { X je prvni prvek}
            else
              begin     { X neni prvni prvek }
                while PredPom^.Dalsi <> Pom do PredPom := PredPom^.Dalsi;
                PredPom^.Dalsi := Pom^.Dalsi;
              end;
          dispose (Pom);
          exit;
        end;  {nalezen}
      Pom := Pom^.Dalsi;
    end;  {while}
end;  {Erase}
{-------------------------  SeznPrint  --------------------------------------}
procedure SeznPrint (Uk: Seznam);
begin  {SeznPrint}
  writeln;
  while Uk <> nil do
    begin {while}
      Writeln (Uk^.Obsah);
      Uk := Uk^.Dalsi
    end;  {while}
end;   {SeznPrint}
{--------------------------  SeznKill  --------------------------------------}
procedure SeznKill (var Uk: Seznam);
var Pom : Seznam;
begin {SeznKill}
  while Uk <> nil do
    begin {while}
      Pom := Uk;
      Uk := Uk^.Dalsi;
      dispose (Pom);
    end;  {while}
end;  {SeznKill}

{----------------------------------------------------------------------------}

{                   ***********************************                      }
{                   *******   TEXTOVY SOUBOR   ********                      }
{                   ***********************************                      }

{--------------------------  ReadLine  --------------------------------------}
{  fce nacte radek ze souboru Fil do radku typu Line}
function ReadLine (var Fil: text): string;
var Z : char;
    R : string;

begin {ReadLine}
  R := '';
  while not eoln (Fil) do
    begin
      read (Fil,Z);
      R := R + Z;
    end;
  readln (Fil);
  ReadLine := R;
end;  {ReadLine}
{--------------------------  WriteLine  -------------------------------------}
{  Procedura ulozi dany Radek R delky N do souboru Fil a odradkuje
   na dalsi Radek  }
procedure WriteLine (var Fil: text; R: string);
var N, i : byte;
    Z    : char;

begin  {WriteLine}
 N := length(R);
 for i := 1 to N do write (Fil, R [i]);
 writeln (Fil);
end;  {WriteLine}
{--------------------------   PrintLine  ------------------------------------}
procedure PrintLine (R: string);
var N, i : byte;

begin  {PrintLine}
  N := length (R);
  for i := 1 to N do write (R [i]);
end;   {PrintLine}


{----------------------------------------------------------------------------}
{          ****************************************************              }
{          *******   OSTATNI DROBNE PROCEDURKY A FCE   ********              }
{          ****************************************************              }
{----------------------------------------------------------------------------}

{------------------------------  SetColors  ---------------------------------}
procedure SetColors (Ink, Back: byte);
begin { SetColors }
  TextColor (Ink);
  TextBackGround (Back);
end;  { SetColors }

{-----------------------------------  Beep  ---------------------------------}
procedure Beep (Ton, Time: Word);
begin { Beep }
  Sound (Ton);
  Delay (Time);
  NoSound;
end;  { Beep }
{--------------------------------  WriteXY  ---------------------------------}
procedure WriteXY (X, Y: Byte; Co: string);
begin { WriteXY }
  GotoXY (X,Y);
  Write (Co);
end;  { WriteXY }
{-----------------------------  SaveAttrib  ---------------------------------}
{ Ulozi hlavni atributy (poloha cursoru, barva pisma, pozadi) do promenne
  OldAttr                                                                    }
procedure SaveAttrib (Var OldAttr: Attrib);
begin { SaveAttrib }
  OldAttr.X := WhereX;
  OldAttr.Y := WhereY;
  OldAttr.At := TextAttr;
end;  { SaveAttrib }
{-----------------------------  LoadAttrib  ---------------------------------}
{ Zmeni hlavni atributy podle promenne OldAttr                               }
procedure LoadAttrib (OldAttr: Attrib);
begin { LoadAttrib }
  GotoXY (OldAttr.X, OldAttr.Y);
  TextAttr := OldAttr.At;
end;  { LoadAttrib }
{-------------------------  StandartScreen  ---------------------------------}
procedure StandartScreen;
begin { StandartScreen }
  SetColors (7,0);
  ClrScr;
end;  { StandartScreen }
{---------------------------------  Pozadi  ---------------------------------}
procedure Pozadi (Vzor: string; Color: Byte);
var
  i : integer;
  OldAttr: Attrib;
begin { Pozadi }
  SaveAttrib (OldAttr);
  SetColors (Color + 8, Color);
  For i := 1 to (1999 div Length (Vzor) ) do
    Write (Vzor);
  LoadAttrib (OldAttr);
end;  { Pozadi }

{==========================   Vlastni telo   ================================}
begin
end.
{============================================================================}